local addonName, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
local gsub = _G.string.gsub 
local find = _G.string.find
local sub = _G.string.sub 
local upper = _G.string.upper
local L=addonTable.locale
------------
local Create=addonTable.Create
local PIGEnter=Create.PIGEnter
local PIGFrame=Create.PIGFrame
local PIGLine=Create.PIGLine
local PIGButton = Create.PIGButton
local PIGDownMenu=Create.PIGDownMenu
local PIGSlider = Create.PIGSlider
local PIGCheckbutton=Create.PIGCheckbutton
local PIGCheckbutton_R=Create.PIGCheckbutton_R
local PIGOptionsList=Create.PIGOptionsList
local PIGOptionsList_RF=Create.PIGOptionsList_RF
local PIGOptionsList_R=Create.PIGOptionsList_R
local PIGFontString=Create.PIGFontString
local PIGFontStringBG=Create.PIGFontStringBG
local PIGCloseBut=Create.PIGCloseBut
--===============================
local QuickChatfun=addonTable.QuickChatfun
local PIG_renwuming
QuickChatfun["Keyword"] = {}
QuickChatfun["Blacklist"] = {}
local function fengeguanjianzi(str,delimiter)---分割字符
    local dLen = string.len(delimiter)
    local newDeli = ""
    for i=1,dLen,1 do
        newDeli = newDeli .. "["..delimiter:sub(i,i).."]"
    end
    local locaStart,locaEnd = str:find(newDeli)
    local arr = {}
    local n = 1
    while locaStart ~= nil
    do
        if locaStart>0 then
            arr[n] = str:sub(1,locaStart-1)
            n = n + 1
        end
        str = str:sub(locaEnd+1,string.len(str))
        locaStart,locaEnd = str:find(newDeli)
    end
    if str ~= nil and str ~= "" and str ~= " " then
        arr[n] = str
    end
    return arr
end
local function del_teshuzifu(txtlist)--去除特殊字符
	local NEWtxtlist={}
	for x=1,#txtlist do
		local txtlist_hang={}
		for xx=1,#txtlist[x] do
			local tihuanteshuzifu=txtlist[x][xx]
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%^","%%^");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%$","%%$");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%%","%%%");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%*","%%*");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%+","%%+");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%-","%%-");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%.","%%.");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%?","%%?");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%(","%%(");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%)","%%)");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%[","%%[");
			local tihuanteshuzifu=tihuanteshuzifu:gsub("%]","%%]");
			local tihuanteshuzifu=tihuanteshuzifu:upper()--转换大小写
			table.insert(txtlist_hang, tihuanteshuzifu);
		end
		table.insert(NEWtxtlist, txtlist_hang);
	end
	return NEWtxtlist
end
QuickChatfun.del_teshuzifu=del_teshuzifu
local function geshihua_txt(laiyuan)--格式化字符
	local NEWtxtlist=del_teshuzifu(PIGA["Chat"]["TiquKey"][laiyuan][PIG_renwuming])
	PIGA["Chat"]["TiquKey"][laiyuan][PIG_renwuming]=NEWtxtlist
	QuickChatfun[laiyuan]=NEWtxtlist
end
local function Save_KeyValue(fuji,leixing,Scroll)
	local value = fuji:GetText();
	local value = value:gsub(" ", "")
	if value~="" then
		local value = value:gsub("，", ",")
		local guanjianzilist = fengeguanjianzi(value, ",")
		table.insert(PIGA["Chat"]["TiquKey"][leixing][PIG_renwuming],guanjianzilist)
		geshihua_txt(leixing)
		Scroll.gengxin_list(Scroll)
	end
	fuji.tishi:Show()
	fuji.YES:Hide();
	fuji:SetText("");
	fuji:ClearFocus()
end
--------------------
function QuickChatfun.QuickBut_Keyword()
	local wanjia, realm = UnitFullName("player")
	local realm=realm or GetRealmName()
	PIG_renwuming = wanjia.."-"..realm
	if not PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming] then PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming]={} end
	if not PIGA["Chat"]["TiquKey"]["Blacklist"][PIG_renwuming] then PIGA["Chat"]["TiquKey"]["Blacklist"][PIG_renwuming]={} end
	local fuFrame=QuickChatFFF_UI
	local fuWidth = fuFrame.Width
	local Width,Height = fuWidth,fuWidth
	local ziframe = {fuFrame:GetChildren()}
	if PIGA["Chat"]["QuickChat_style"]==1 then
		fuFrame.Keyword = CreateFrame("Button",nil,fuFrame); 
	elseif PIGA["Chat"]["QuickChat_style"]==2 then
		fuFrame.Keyword = CreateFrame("Button",nil,fuFrame, "UIMenuButtonStretchTemplate"); 
	end
	fuFrame.Keyword:SetSize(Width,Height);
	fuFrame.Keyword:SetPoint("LEFT",fuFrame,"LEFT",#ziframe*Width,0);
	fuFrame.Keyword.Tex = fuFrame.Keyword:CreateTexture();
	fuFrame.Keyword.Tex:SetTexture("interface/common/voicechat-on.blp");
	fuFrame.Keyword.Tex:SetSize(Width+2,Height-4);
	fuFrame.Keyword.Tex:SetPoint("CENTER", -7.5, 0);
	fuFrame.Keyword.Tex:SetDrawLayer("BORDER", -1)
	fuFrame.Keyword.TexNO = fuFrame.Keyword:CreateTexture();
	fuFrame.Keyword.TexNO:SetTexture("interface/common/voicechat-muted.blp");
	fuFrame.Keyword.TexNO:SetSize(Width-9,Height-9);
	fuFrame.Keyword.TexNO:SetAlpha(0.7);
	fuFrame.Keyword.TexNO:SetPoint("CENTER", 0, 0);
	if PIGA["Chat"]["TiquKey"]["Open"] then
		fuFrame.Keyword.TexNO:Hide()
	else
		fuFrame.Keyword.TexNO:Show()
	end
	fuFrame.Keyword:SetScript("OnMouseDown",  function(self)
		self.Tex:SetPoint("CENTER", -6, -1.5);
	end)
	fuFrame.Keyword:SetScript("OnMouseUp",  function(self)
		self.Tex:SetPoint("CENTER", -7.5, 0);
	end)
	PIGEnter(fuFrame.Keyword,"|cff00FFff"..KEY_BUTTON1.."-|r|cffFFFF00"..DISPLAY..L["CHAT_KEYWORD"]..WITHDRAW..UIOPTIONS_MENU.."\n|cff00FFff"..KEY_BUTTON2.."-|r|cffFFFF00"..ENABLE.."/"..CLOSE..WITHDRAW.."|r")
	fuFrame.Keyword:RegisterForClicks("LeftButtonUp","RightButtonUp")
	fuFrame.Keyword:SetScript("OnClick", function(self,button)
		if button=="LeftButton" then
			if self.F:IsShown() then
				self.F:Hide()
			else
				self.F:Show()
			end
		else
			if PIGA["Chat"]["TiquKey"]["Open"] then
				PIGA["Chat"]["TiquKey"]["Open"]=false
				fuFrame.Keyword.TexNO:Show()
				PIGinfotip:TryDisplayMessage(CLOSE..L["CHAT_KEYWORD"]..WITHDRAW, YELLOW_FONT_COLOR:GetRGB());
			else
				PIGA["Chat"]["TiquKey"]["Open"]=true
				fuFrame.Keyword.TexNO:Hide()
				PIGinfotip:TryDisplayMessage(ENABLE..L["CHAT_KEYWORD"]..WITHDRAW, YELLOW_FONT_COLOR:GetRGB());
			end
		end
	end);
	----
	fuFrame.Keyword.F = CreateFrame("ScrollingMessageFrame", "ChatFrame99", fuFrame.Keyword, "ChatFrameTemplate")
	fuFrame.Keyword.F:SetHeight(200);
	fuFrame.Keyword.F:SetFrameStrata("LOW")
	fuFrame.Keyword.F:EnableMouse(false)
	fuFrame.Keyword.F:UnregisterAllEvents()
	--fuFrame.Keyword.F:Clear() -- 清除框架中的消息 
	--fuFrame.Keyword.F:SetFadeDuration(seconds)--设置淡入淡出持续时间 
	--fuFrame.Keyword.F:SetTimeVisible(seconds)--设置消息显示时间
	--fuFrame.Keyword.F:SetFading(false)淡入淡出
	--fuFrame.Keyword.F:SetMaxLines(999) --设置可显示最大行数
	--fuFrame.Keyword.F:SetInsertMode(TOP or BOTTOM) --设置新消息的插入位置
	--fuFrame.Keyword.F:SetToplevel(true)--单击子项时框架是否应自行升起
   	--fuFrame.Keyword.F:EnableMouseWheel(false)-- 禁用鼠标滚动
	fuFrame.Keyword.F:SetHyperlinksEnabled(true)--可点击
	if PIGA["Chat"]["TiquKey"]["FontSize"] then
		FCF_SetChatWindowFontSize(nil, ChatFrame99, PIGA["Chat"]["TiquKey"]["FontSize_value"])
	end

	fuFrame.Keyword.F.Background = fuFrame.Keyword.F:CreateTexture(nil, "BACKGROUND");
	fuFrame.Keyword.F.Background:SetTexture("Interface/ChatFrame/ChatFrameBackground");
	fuFrame.Keyword.F.Background:SetPoint("TOPLEFT",ChatFrame99,"TOPLEFT",0,0);
	fuFrame.Keyword.F.Background:SetPoint("BOTTOMRIGHT",ChatFrame99,"BOTTOMRIGHT",23,0);
	if PIGA["Chat"]["TiquKey"]["KeywordFShow"] then
		fuFrame.Keyword.F:Show();
	else
		fuFrame.Keyword.F:Hide();
	end
	fuFrame.Keyword.F:HookScript("OnShow", function(self)
		PIGA["Chat"]["TiquKey"]["KeywordFShow"]=true
	end);
	fuFrame.Keyword.F:HookScript("OnHide", function(self)
		PIGA["Chat"]["TiquKey"]["KeywordFShow"]=false
	end);
	fuFrame.Keyword.F:SetScript("OnMouseWheel", function(self, delta)
		if delta == 1 then
			fuFrame.Keyword.F:ScrollUp()
			fuFrame.Keyword.F.ScrollToBottomButton.hilight:Show();
		elseif delta == -1 then
			fuFrame.Keyword.F:ScrollDown()
			if fuFrame.Keyword.F:GetScrollOffset()==0 then
				fuFrame.Keyword.F.ScrollToBottomButton.hilight:Hide();
			end
		end
	end)
	geshihua_txt("Keyword")
	geshihua_txt("Blacklist")
	---翻页按钮=======================
	local anniudaxiaoF = 24
	fuFrame.Keyword.F.ScrollToBottomButton = CreateFrame("Button",nil,fuFrame.Keyword.F);
	fuFrame.Keyword.F.ScrollToBottomButton:SetNormalTexture("interface/chatframe/ui-chaticon-scrollend-up.blp")
	fuFrame.Keyword.F.ScrollToBottomButton:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	fuFrame.Keyword.F.ScrollToBottomButton:SetPushedTexture("interface/chatframe/ui-chaticon-scrollend-down.blp")
	fuFrame.Keyword.F.ScrollToBottomButton:SetSize(anniudaxiaoF,anniudaxiaoF);
	fuFrame.Keyword.F.ScrollToBottomButton:SetPoint("BOTTOMLEFT",fuFrame.Keyword.F,"BOTTOMRIGHT",0,12);
	fuFrame.Keyword.F.ScrollToBottomButton.hilight = fuFrame.Keyword.F.ScrollToBottomButton:CreateTexture(nil,"OVERLAY");
	fuFrame.Keyword.F.ScrollToBottomButton.hilight:SetTexture("interface/chatframe/ui-chaticon-blinkhilight.blp");
	fuFrame.Keyword.F.ScrollToBottomButton.hilight:SetSize(anniudaxiaoF,anniudaxiaoF);
	fuFrame.Keyword.F.ScrollToBottomButton.hilight:SetPoint("CENTER", 0, 0);
	fuFrame.Keyword.F.ScrollToBottomButton.hilight:Hide();
	---------
	fuFrame.Keyword.F.ScrollToBottomButton:SetScript("OnClick", function (self)
		fuFrame.Keyword.F:ScrollToBottom()
		fuFrame.Keyword.F.ScrollToBottomButton.hilight:Hide();
	end);
	--设置==========
	local ButtonH = 22
	fuFrame.Keyword.F.shezhi = CreateFrame("Button",nil,fuFrame.Keyword.F);
	fuFrame.Keyword.F.shezhi:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	fuFrame.Keyword.F.shezhi:SetSize(ButtonH,ButtonH);
	fuFrame.Keyword.F.shezhi:SetPoint("BOTTOM",fuFrame.Keyword.F.ScrollToBottomButton,"TOP",0,6);
	fuFrame.Keyword.F.shezhi.Tex = fuFrame.Keyword.F.shezhi:CreateTexture(nil, "BORDER");
	fuFrame.Keyword.F.shezhi.Tex:SetTexture("interface/gossipframe/bindergossipicon.blp");
	fuFrame.Keyword.F.shezhi.Tex:SetPoint("CENTER");
	fuFrame.Keyword.F.shezhi.Tex:SetSize(ButtonH-4,ButtonH-4);
	fuFrame.Keyword.F.shezhi:SetScript("OnMouseDown", function (self)
		self.Tex:SetPoint("CENTER",-1.2,-1.2);
	end);
	fuFrame.Keyword.F.shezhi:SetScript("OnMouseUp", function (self)
		self.Tex:SetPoint("CENTER");
	end);
	fuFrame.Keyword.F.shezhi:SetScript("OnClick", function (self)		
		if self.F:IsShown() then
			self.F:Hide()
		else
			self.F:Show()
		end	
	end);
	fuFrame.Keyword.F.shezhi.F=PIGFrame(fuFrame.Keyword.F.shezhi,nil,nil,nil,true)
	fuFrame.Keyword.F.shezhi.F:PIGSetBackdrop(0.9)
	fuFrame.Keyword.F.shezhi.F:PIGClose()
	fuFrame.Keyword.F.shezhi.F:SetHeight(190);
	fuFrame.Keyword.F.shezhi.F:SetPoint("BOTTOMLEFT",fuFrame.Keyword.F,"BOTTOMLEFT",8,4);
	fuFrame.Keyword.F.shezhi.F:SetPoint("BOTTOMRIGHT",fuFrame.Keyword.F,"BOTTOMRIGHT",-4,4);
	fuFrame.Keyword.F.shezhi.F:Hide()
	--选项
	fuFrame.Keyword.F.shezhi.F.xitongjihuoB = PIGCheckbutton(fuFrame.Keyword.F.shezhi.F,{"TOPLEFT",fuFrame.Keyword.F.shezhi.F,"TOPLEFT",10,-10},L["CHAT_KEYWORD_SET1"])
	fuFrame.Keyword.F.shezhi.F.xitongjihuoB:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Chat"]["TiquKey"]["xitongjihuoB"]=true
		else
			PIGA["Chat"]["TiquKey"]["xitongjihuoB"]=false
		end
	end);
	fuFrame.Keyword.F.shezhi.F.guolvzishen = PIGCheckbutton(fuFrame.Keyword.F.shezhi.F,{"TOPLEFT",fuFrame.Keyword.F.shezhi.F.xitongjihuoB,"BOTTOMLEFT",0,-10},L["CHAT_KEYWORD_SET2"])
	fuFrame.Keyword.F.shezhi.F.guolvzishen:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Chat"]["TiquKey"]["guolvzishen"]=true
		else
			PIGA["Chat"]["TiquKey"]["guolvzishen"]=false
		end
	end);
	--
	fuFrame.Keyword.F.shezhi.F.guolvchongfu = PIGCheckbutton(fuFrame.Keyword.F.shezhi.F,{"TOPLEFT",fuFrame.Keyword.F.shezhi.F.guolvzishen,"BOTTOMLEFT",0,-10},L["CHAT_KEYWORD_SET3"])
	fuFrame.Keyword.F.shezhi.F.guolvchongfu:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Chat"]["TiquKey"]["guolvchongfu"]=true
		else
			PIGA["Chat"]["TiquKey"]["guolvchongfu"]=false
		end
	end);
	--高度
	fuFrame.Keyword.F.shezhi.F.GaoduHSlider =PIGSlider(fuFrame.Keyword.F.shezhi.F,{"TOPLEFT",fuFrame.Keyword.F.shezhi.F.guolvchongfu,"BOTTOMLEFT",60,-20},{100,14},{100,500,1},"")
	fuFrame.Keyword.F.shezhi.F.GaoduHSlider.t = PIGFontString(fuFrame.Keyword.F.shezhi.F.GaoduHSlider,{"RIGHT",fuFrame.Keyword.F.shezhi.F.GaoduHSlider,"LEFT",-10,0},INTERFACE_LABEL..HIGH);
	fuFrame.Keyword.F.shezhi.F.GaoduHSlider:SetScript("OnValueChanged", function(self)
		local val = self:GetValue()
		self.Text:SetText(val);
		fuFrame.Keyword.F:SetHeight(val)
		PIGA["Chat"]["TiquKey"]["gaoduH"]=val
	end)
	fuFrame.Keyword.F.shezhi.F.GaoduHSlider:SetValue(PIGA["Chat"]["TiquKey"]["gaoduH"]);
	--颜色透明度
	if tocversion<80000 then
		local xiayiinfo = {0,1,0.1}
		fuFrame.Keyword.F.shezhi.F.ColorSlider = PIGSlider(fuFrame.Keyword.F.shezhi.F,{"TOPLEFT",fuFrame.Keyword.F.shezhi.F.GaoduHSlider,"BOTTOMLEFT",0,-30},{100,14},xiayiinfo)
		fuFrame.Keyword.F.shezhi.F.ColorSlider.t = PIGFontString(fuFrame.Keyword.F.shezhi.F.ColorSlider,{"RIGHT",fuFrame.Keyword.F.shezhi.F.ColorSlider,"LEFT",-10,0},OPACITY)
		fuFrame.Keyword.F.shezhi.F.ColorSlider:SetScript("OnValueChanged", function(self)
			local Hval = self:GetValue()
			local Hval = Hval*10+0.5
			local Hval = floor(Hval)*0.1
			self.Text:SetText(Hval);
			PIGA["Chat"]["TiquKey"]["BgColor"][4]=Hval;
			fuFrame.Keyword.F.Background:SetVertexColor(unpack(PIGA["Chat"]["TiquKey"]["BgColor"]))
		end)
		fuFrame.Keyword.F.shezhi.F.ColorSlider:SetValue(PIGA["Chat"]["TiquKey"]["BgColor"][4]);
	else
		local newR, newG, newB, newA = unpack(PIGA["Chat"]["TiquKey"]["BgColor"])
		fuFrame.Keyword.F.Background:SetVertexColor(newR, newG, newB, newA)
		local function SETColorCallback(restore)
			local newR, newG, newB, newA;
			if restore then
				newR, newG, newB, newA = restore.r, restore.g, restore.b, restore.opacity
			else
				newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
			end
			fuFrame.Keyword.F.Background:SetVertexColor(newR, newG, newB, newA)
			fuFrame.Keyword.F.shezhi.F.Color.Color:SetVertexColor(newR, newG, newB, newA)
			PIGA["Chat"]["TiquKey"]["BgColor"]={newR, newG, newB, newA}
		end
		fuFrame.Keyword.F.shezhi.F.Color = CreateFrame("Button", nil, fuFrame.Keyword.F.shezhi.F, "ColorSwatchTemplate")
		fuFrame.Keyword.F.shezhi.F.Color:SetPoint("TOPLEFT",fuFrame.Keyword.F.shezhi.F,"TOPLEFT",260,-100);
		fuFrame.Keyword.F.shezhi.F.Color:SetSize(26,26);
		fuFrame.Keyword.F.shezhi.F.Color.Color:SetVertexColor(newR, newG, newB, newA)	
		fuFrame.Keyword.F.shezhi.F.Color:SetScript("OnClick", function (self)
			local info={}
			info.r, info.g, info.b, info.opacity = fuFrame.Keyword.F.Background:GetVertexColor()
			info.hasOpacity = true
			info.swatchFunc=SETColorCallback
			info.opacityFunc=SETColorCallback
			info.cancelFunc=SETColorCallback
			OpenColorPicker(info);
		end);
	end
	fuFrame.Keyword.F.shezhi.F:HookScript("OnShow", function (self)	
		fuFrame.Keyword.F.shezhi.F.guolvzishen:SetChecked(PIGA["Chat"]["TiquKey"]["guolvzishen"])
		fuFrame.Keyword.F.shezhi.F.xitongjihuoB:SetChecked(PIGA["Chat"]["TiquKey"]["xitongjihuoB"])
		fuFrame.Keyword.F.shezhi.F.guolvchongfu:SetChecked(PIGA["Chat"]["TiquKey"]["guolvchongfu"])
	end)
	--编辑关键字/黑名单================================
	fuFrame.Keyword.F.Keyword = CreateFrame("Button",nil,fuFrame.Keyword.F);
	fuFrame.Keyword.F.Keyword:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	fuFrame.Keyword.F.Keyword:SetSize(ButtonH,ButtonH);
	fuFrame.Keyword.F.Keyword:SetPoint("BOTTOM",fuFrame.Keyword.F.shezhi,"TOP",0,6);
	fuFrame.Keyword.F.Keyword.Tex = fuFrame.Keyword.F.Keyword:CreateTexture(nil, "BORDER");
	fuFrame.Keyword.F.Keyword.Tex:SetTexture("interface/buttons/ui-guildbutton-publicnote-up.blp");
	fuFrame.Keyword.F.Keyword.Tex:SetPoint("CENTER");
	fuFrame.Keyword.F.Keyword.Tex:SetSize(ButtonH-4,ButtonH-4);
	fuFrame.Keyword.F.Keyword:SetScript("OnMouseDown", function (self)
		self.Tex:SetPoint("CENTER",-1.2,-1.2);
	end);
	fuFrame.Keyword.F.Keyword:SetScript("OnMouseUp", function (self)
		self.Tex:SetPoint("CENTER");
	end);
	fuFrame.Keyword.F.Keyword:RegisterForClicks("LeftButtonUp","RightButtonUp")
	fuFrame.Keyword.F.Keyword:SetScript("OnClick", function (self,button)
		if button=="LeftButton" then
			if self.F:IsShown() then
				self.F:Hide()
			else
				self.F:Show()
			end
		else
			ChatFrame99:Clear()
		end
	end);
	local GJZW ,GJZH, hang_H, hang_NUM=600,400,23,12
	fuFrame.Keyword.F.Keyword.F=PIGFrame(fuFrame.Keyword.F.Keyword,nil,nil,"Keyword_addKeyUI",true)
	fuFrame.Keyword.F.Keyword.F:PIGSetBackdrop()
	fuFrame.Keyword.F.Keyword.F:PIGSetMovable()
	fuFrame.Keyword.F.Keyword.F:PIGClose()
	fuFrame.Keyword.F.Keyword.F:SetSize(GJZW ,GJZH);
	fuFrame.Keyword.F.Keyword.F:SetPoint("CENTER",UIParent,"CENTER",0,0);
	fuFrame.Keyword.F.Keyword.F:Hide()
	fuFrame.Keyword.F.Keyword.F.biaoti = PIGFontString(fuFrame.Keyword.F.Keyword.F,{"TOP", fuFrame.Keyword.F.Keyword.F, "TOP", 0, -4},EDIT..L["CHAT_KEYWORD"].."/"..L["CHAT_KEYWORD_B"]);
	fuFrame.Keyword.F.Keyword.F.line1=PIGLine(fuFrame.Keyword.F.Keyword.F,"TOP",-20)
	--L
	fuFrame.Keyword.F.Keyword.F.L=PIGFrame(fuFrame.Keyword.F.Keyword.F)
	fuFrame.Keyword.F.Keyword.F.L:PIGSetBackdrop()
	fuFrame.Keyword.F.Keyword.F.L:SetPoint("TOPLEFT",fuFrame.Keyword.F.Keyword.F.line1,"BOTTOMLEFT",4,-4);
	fuFrame.Keyword.F.Keyword.F.L:SetPoint("BOTTOMRIGHT",fuFrame.Keyword.F.Keyword.F,"BOTTOMRIGHT",-GJZW/2-4,4);
	fuFrame.Keyword.F.Keyword.F.L.line1=PIGLine(fuFrame.Keyword.F.Keyword.F.L,"TOP",-26)
	--关键字
	fuFrame.Keyword.F.Keyword.F.L.T = PIGFontString(fuFrame.Keyword.F.Keyword.F.L,{"TOPLEFT",fuFrame.Keyword.F.Keyword.F.L,"TOPLEFT",8,-6},WITHDRAW..L["CHAT_KEYWORD"]);
	fuFrame.Keyword.F.Keyword.F.L.daoru=PIGDownMenu(fuFrame.Keyword.F.Keyword.F.L,{"LEFT",fuFrame.Keyword.F.Keyword.F.L.T,"RIGHT", 4,0},{160,nil})
	fuFrame.Keyword.F.Keyword.F.L.daoru:SetScale(0.9)
	fuFrame.Keyword.F.Keyword.F.L.daoru:PIGDownMenu_SetText(L["CONFIG_DAORU"])
	function fuFrame.Keyword.F.Keyword.F.L.daoru:PIGDownMenu_Update_But(self)
		local jueseListLL = PIGA["Chat"]["TiquKey"]["Keyword"];
		local info = {}
		info.func = self.PIGDownMenu_SetValue
		for k,v in pairs(jueseListLL) do
			if k~=PIG_renwuming then
				info.text, info.arg1 = L["CONFIG_DAORU"].."["..k.."]("..#v..")", k
				info.notCheckable = true;
				fuFrame.Keyword.F.Keyword.F.L.daoru:PIGDownMenu_AddButton(info)
			end
		end
	end
	function fuFrame.Keyword.F.Keyword.F.L.daoru:PIGDownMenu_SetValue(value,arg1,arg2)
		local info = {}
		for xx=1,#PIGA["Chat"]["TiquKey"]["Keyword"][arg1] do
			table.insert(info, PIGA["Chat"]["TiquKey"]["Keyword"][arg1][xx])
		end
		PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming] = info
		fuFrame.Keyword.F.Keyword.F.L.WList.Scroll.gengxin_list(fuFrame.Keyword.F.Keyword.F.L.WList.Scroll)
		PIGCloseDropDownMenus()
	end
	local function Focus_ShowHide(self1,self2,ShowHide)
		if ShowHide then
			self1.tishi:Hide()
			self1.YES:Show()
			self1:SetText("")
			self2.tishi:Show()
			self2.YES:Hide()
		else
			self1.tishi:Show()
			self1.YES:Hide()
			self1:SetText("")
		end
	end
	fuFrame.Keyword.F.Keyword.F.L.EW = CreateFrame("EditBox", nil, fuFrame.Keyword.F.Keyword.F.L,"InputBoxInstructionsTemplate");
	fuFrame.Keyword.F.Keyword.F.L.EW:SetSize(200,ButtonH);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetPoint("TOPLEFT", fuFrame.Keyword.F.Keyword.F.L.line1, "BOTTOMLEFT", 10,-2);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetFontObject(ChatFontNormal);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetMaxLetters(20);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetAutoFocus(false);
	fuFrame.Keyword.F.Keyword.F.L.EW.tishi = PIGFontString(fuFrame.Keyword.F.Keyword.F.L,{"LEFT",fuFrame.Keyword.F.Keyword.F.L.EW,"LEFT",6,0},L["CHAT_KEYWORD_TI"]);
	fuFrame.Keyword.F.Keyword.F.L.EW.tishi:SetTextColor(0.8, 0.8, 0.8, 0.8);
	fuFrame.Keyword.F.Keyword.F.L.EW.YES = PIGButton(fuFrame.Keyword.F.Keyword.F.L.EW,{"LEFT",fuFrame.Keyword.F.Keyword.F.L.EW,"RIGHT",6,0},{50,ButtonH-2},OKAY);
	fuFrame.Keyword.F.Keyword.F.L.EW.YES:Hide();
	fuFrame.Keyword.F.Keyword.F.L.EW:SetScript("OnEscapePressed", function(self)
		Focus_ShowHide(self,nil,false)
		self:ClearFocus()
	end);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetScript("OnEditFocusGained", function(self)
		Focus_ShowHide(self,fuFrame.Keyword.F.Keyword.F.R.EB,true)
	end);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetScript("OnHide", function(self)
		Focus_ShowHide(self,nil,false)
	end);
	fuFrame.Keyword.F.Keyword.F.L.EW:SetScript("OnEnterPressed", function(self)
		Save_KeyValue(self,"Keyword",fuFrame.Keyword.F.Keyword.F.L.WList.Scroll)
	end);
	fuFrame.Keyword.F.Keyword.F.L.EW.YES:SetScript("OnClick", function(self)
		local fujif = self:GetParent();
		Save_KeyValue(fujif,"Keyword",fuFrame.Keyword.F.Keyword.F.L.WList.Scroll)
	end)

	--例子
	fuFrame.Keyword.F.Keyword.F.L.lineW=PIGLine(fuFrame.Keyword.F.Keyword.F.L,"BOT",36)
	local tishineiW = "|cff00FF00"..L["CHAT_KEYWORD_EITW"].."|r"
	fuFrame.Keyword.F.Keyword.F.L.shili = PIGFontString(fuFrame.Keyword.F.Keyword.F.L,{"TOPLEFT",fuFrame.Keyword.F.Keyword.F.L.lineW,"BOTTOMLEFT",4,-4},tishineiW,nil,13);
	fuFrame.Keyword.F.Keyword.F.L.shili:SetJustifyH("LEFT")
	---显示列表
	fuFrame.Keyword.F.Keyword.F.L.WList = PIGFrame(fuFrame.Keyword.F.Keyword.F.L);
	fuFrame.Keyword.F.Keyword.F.L.WList:SetPoint("TOPLEFT", fuFrame.Keyword.F.Keyword.F.L.line1, "TOPLEFT", 0, -28);
	fuFrame.Keyword.F.Keyword.F.L.WList:SetPoint("BOTTOMRIGHT", fuFrame.Keyword.F.Keyword.F.L.lineW, "TOPRIGHT", 0, 0);
	fuFrame.Keyword.F.Keyword.F.L.WList.Scroll = CreateFrame("ScrollFrame",nil,fuFrame.Keyword.F.Keyword.F.L.WList, "FauxScrollFrameTemplate");  
	fuFrame.Keyword.F.Keyword.F.L.WList.Scroll:SetPoint("TOPLEFT",fuFrame.Keyword.F.Keyword.F.L.WList,"TOPLEFT",0,-1);
	fuFrame.Keyword.F.Keyword.F.L.WList.Scroll:SetPoint("BOTTOMRIGHT",fuFrame.Keyword.F.Keyword.F.L.WList,"BOTTOMRIGHT",-22,1);
	fuFrame.Keyword.F.Keyword.F.L.WList.Scroll.ScrollBar:SetScale(0.8);
	fuFrame.Keyword.F.Keyword.F.L.WList.Scroll:SetScript("OnVerticalScroll", function(self, offset)
	    FauxScrollFrame_OnVerticalScroll(self, offset, hang_H, self.gengxin_list)
	end)
	function fuFrame.Keyword.F.Keyword.F.L.WList.Scroll.gengxin_list(self)
		for id = 1, hang_NUM, 1 do	
			_G["KeyWList_"..id]:Hide();
		end
		local ItemsNum = #PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming];
		if ItemsNum>0 then
		    FauxScrollFrame_Update(self, ItemsNum, hang_NUM, hang_H);
		    local offset = FauxScrollFrame_GetOffset(self);
			for id = 1, hang_NUM do
				local dangqian = id+offset;
				if PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming][dangqian] then
					local fujik = _G["KeyWList_"..id]
					fujik:Show();
					fujik.del:SetID(dangqian);
					local guanjianzineironglianji = ""
					for xx=1,#PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming][dangqian] do
						if PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming][dangqian][xx] then
							if xx==#PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming][dangqian] then
								guanjianzineironglianji=guanjianzineironglianji..PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming][dangqian][xx]
							else
								guanjianzineironglianji=guanjianzineironglianji..PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming][dangqian][xx]..","
							end
						end
					end
					fujik.txt:SetText(guanjianzineironglianji);
				end
			end
		end
	end
	local WListWW = fuFrame.Keyword.F.Keyword.F.L.WList:GetWidth()
	for id = 1, hang_NUM, 1 do
		local ListBut = CreateFrame("Frame", "KeyWList_"..id, fuFrame.Keyword.F.Keyword.F.L.WList);
		ListBut:SetSize(WListWW,hang_H);
		if id==1 then
			ListBut:SetPoint("TOPLEFT", fuFrame.Keyword.F.Keyword.F.L.WList.Scroll, "TOPLEFT", 0, 0);
		else
			ListBut:SetPoint("TOPLEFT", _G["KeyWList_"..(id-1)], "BOTTOMLEFT", 0, 0);
		end	
		PIGLine(ListBut,"TOP",0,1,{1,-20},{0.5, 0.5, 0.5, 0.2})
		ListBut.del =PIGCloseBut(ListBut,{"LEFT", ListBut, "LEFT", 0,0})
		ListBut.del:SetScript("OnClick", function (self)
			table.remove(PIGA["Chat"]["TiquKey"]["Keyword"][PIG_renwuming], self:GetID());
			fuFrame.Keyword.F.Keyword.F.L.WList.Scroll.gengxin_list(fuFrame.Keyword.F.Keyword.F.L.WList.Scroll)
		end);	
		ListBut.txt = PIGFontString(ListBut,{"LEFT", ListBut.del, "RIGHT", 4, 0});
		ListBut.txt:SetTextColor(0.7, 0.7, 0.7, 1);
	end
	fuFrame.Keyword.F.Keyword.F.L.WList:HookScript("OnShow", function(self)
		self.Scroll.gengxin_list(self.Scroll)
	end);

	--黑名单
	fuFrame.Keyword.F.Keyword.F.R=PIGFrame(fuFrame.Keyword.F.Keyword.F)
	fuFrame.Keyword.F.Keyword.F.R:PIGSetBackdrop()
	fuFrame.Keyword.F.Keyword.F.R:SetPoint("TOPLEFT",fuFrame.Keyword.F.Keyword.F.L,"TOPRIGHT",4,0);
	fuFrame.Keyword.F.Keyword.F.R:SetPoint("BOTTOMRIGHT",fuFrame.Keyword.F.Keyword.F,"BOTTOMRIGHT",-4,4);
	fuFrame.Keyword.F.Keyword.F.R.line1=PIGLine(fuFrame.Keyword.F.Keyword.F.R,"TOP",-26)
	fuFrame.Keyword.F.Keyword.F.R.T1 = PIGFontString(fuFrame.Keyword.F.Keyword.F.R,{"TOPLEFT",fuFrame.Keyword.F.Keyword.F.R,"TOPLEFT",8,-6},CALENDAR_FILTERS..L["CHAT_KEYWORD_B"]);
	fuFrame.Keyword.F.Keyword.F.R.daoru_B=PIGDownMenu(fuFrame.Keyword.F.Keyword.F.R,{"LEFT",fuFrame.Keyword.F.Keyword.F.R.T1,"RIGHT", 4,0},{160,nil})
	fuFrame.Keyword.F.Keyword.F.R.daoru_B:SetScale(0.9)
	fuFrame.Keyword.F.Keyword.F.R.daoru_B:PIGDownMenu_SetText(L["CONFIG_DAORU"])
	function fuFrame.Keyword.F.Keyword.F.R.daoru_B:PIGDownMenu_Update_But(self)
		local jueseListxx = PIGA["Chat"]["TiquKey"]["Blacklist"];
		local info = {}
		info.func = self.PIGDownMenu_SetValue
		for k,v in pairs(jueseListxx) do
			if k~=PIG_renwuming then
				info.text, info.arg1 = L["CONFIG_DAORU"].."["..k.."]("..#v..")", k
				info.notCheckable = true;
				fuFrame.Keyword.F.Keyword.F.R.daoru_B:PIGDownMenu_AddButton(info)
			end
		end
	end
	function fuFrame.Keyword.F.Keyword.F.R.daoru_B:PIGDownMenu_SetValue(value,arg1,arg2)
		local info = {}
		for xx=1,#PIGA["Chat"]["TiquKey"]["Blacklist"][arg1] do
			table.insert(info, PIGA["Chat"]["TiquKey"]["Blacklist"][arg1][xx])
		end
		PIGA["Chat"]["TiquKey"]["Blacklist"][PIG_renwuming] = info
		fuFrame.Keyword.F.Keyword.F.R.BList.Scroll.gengxin_list(fuFrame.Keyword.F.Keyword.F.R.BList.Scroll)
		PIGCloseDropDownMenus()
	end
	fuFrame.Keyword.F.Keyword.F.R.EB = CreateFrame("EditBox", nil, fuFrame.Keyword.F.Keyword.F.R,"InputBoxInstructionsTemplate");
	fuFrame.Keyword.F.Keyword.F.R.EB:SetSize(200,ButtonH);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetPoint("TOPLEFT", fuFrame.Keyword.F.Keyword.F.R.line1, "BOTTOMLEFT", 10,-2);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetFontObject(ChatFontNormal);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetMaxLetters(20);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetAutoFocus(false);
	fuFrame.Keyword.F.Keyword.F.R.EB.tishi = PIGFontString(fuFrame.Keyword.F.Keyword.F.R,{"LEFT",fuFrame.Keyword.F.Keyword.F.R.EB,"LEFT",6,0},L["CHAT_KEYWORD_TI"]);
	fuFrame.Keyword.F.Keyword.F.R.EB.tishi:SetTextColor(0.8, 0.8, 0.8, 0.8);
	fuFrame.Keyword.F.Keyword.F.R.EB.YES = PIGButton(fuFrame.Keyword.F.Keyword.F.R.EB,{"LEFT",fuFrame.Keyword.F.Keyword.F.R.EB,"RIGHT",6,0},{50,ButtonH-2},OKAY);
	fuFrame.Keyword.F.Keyword.F.R.EB.YES:Hide();
	fuFrame.Keyword.F.Keyword.F.R.EB:SetScript("OnEscapePressed", function(self) 
		Focus_ShowHide(self,nil,false)
		self:ClearFocus()
	end);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetScript("OnEditFocusGained", function(self)
		Focus_ShowHide(self,fuFrame.Keyword.F.Keyword.F.L.EW,true)
	end);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetScript("OnHide", function(self)
		Focus_ShowHide(self,nil,false)
	end);
	fuFrame.Keyword.F.Keyword.F.R.EB:SetScript("OnEnterPressed", function(self)
		Save_KeyValue(self,"Blacklist",fuFrame.Keyword.F.Keyword.F.R.BList.Scroll)
	end);
	fuFrame.Keyword.F.Keyword.F.R.EB.YES:SetScript("OnClick", function(self)
		local fujif = self:GetParent();
		Save_KeyValue(fujif,"Blacklist",fuFrame.Keyword.F.Keyword.F.R.BList.Scroll)
	end)
	
	---例子
	fuFrame.Keyword.F.Keyword.F.R.lineB=PIGLine(fuFrame.Keyword.F.Keyword.F.R,"BOT",36)
	local tishineiB = "|cffFFFF00"..L["CHAT_KEYWORD_EITB"].."|r"
	fuFrame.Keyword.F.Keyword.F.R.shili = PIGFontString(fuFrame.Keyword.F.Keyword.F.R,{"TOPLEFT",fuFrame.Keyword.F.Keyword.F.R.lineB,"BOTTOMLEFT",4,-4},tishineiB,nil,13);
	fuFrame.Keyword.F.Keyword.F.R.shili:SetJustifyH("LEFT");
	---显示列表
	fuFrame.Keyword.F.Keyword.F.R.BList = PIGFrame(fuFrame.Keyword.F.Keyword.F.R);
	fuFrame.Keyword.F.Keyword.F.R.BList:SetPoint("TOPLEFT", fuFrame.Keyword.F.Keyword.F.R.line1, "TOPLEFT", 0, -28);
	fuFrame.Keyword.F.Keyword.F.R.BList:SetPoint("BOTTOMRIGHT", fuFrame.Keyword.F.Keyword.F.R.lineB, "TOPRIGHT", 0, 0);
	fuFrame.Keyword.F.Keyword.F.R.BList.Scroll = CreateFrame("ScrollFrame",nil,fuFrame.Keyword.F.Keyword.F.R.BList, "FauxScrollFrameTemplate");  
	fuFrame.Keyword.F.Keyword.F.R.BList.Scroll:SetPoint("TOPLEFT",fuFrame.Keyword.F.Keyword.F.R.BList,"TOPLEFT",0,-1);
	fuFrame.Keyword.F.Keyword.F.R.BList.Scroll:SetPoint("BOTTOMRIGHT",fuFrame.Keyword.F.Keyword.F.R.BList,"BOTTOMRIGHT",-22,1);
	fuFrame.Keyword.F.Keyword.F.R.BList.Scroll.ScrollBar:SetScale(0.8);
	fuFrame.Keyword.F.Keyword.F.R.BList.Scroll:SetScript("OnVerticalScroll", function(self, offset)
	    FauxScrollFrame_OnVerticalScroll(self, offset, ButtonH, self.gengxin_list)
	end)
	function fuFrame.Keyword.F.Keyword.F.R.BList.Scroll.gengxin_list(self)
		for id = 1, hang_NUM, 1 do	
			_G["KeyBList_"..id]:Hide();
		end
		local shujuyuan = PIGA["Chat"]["TiquKey"]["Blacklist"][PIG_renwuming];
		local ItemsNum = #shujuyuan
		if ItemsNum>0 then
		    FauxScrollFrame_Update(self, ItemsNum, hang_NUM, ButtonH);
		    local offset = FauxScrollFrame_GetOffset(self);
			for id = 1, hang_NUM do
				local dangqian = id+offset;
				if shujuyuan[dangqian] then
					local fujik = _G["KeyBList_"..id]
					fujik:Show();
					fujik.del:SetID(dangqian);
					local guanjianzineironglianji = ""
					for xx=1,#shujuyuan[dangqian] do
						if shujuyuan[dangqian][xx] then
							if xx==#shujuyuan[dangqian] then
								guanjianzineironglianji=guanjianzineironglianji..shujuyuan[dangqian][xx]
							else
								guanjianzineironglianji=guanjianzineironglianji..shujuyuan[dangqian][xx]..","
							end
						end
					end
					fujik.txt:SetText(guanjianzineironglianji);
				end
			end
		end
	end
	local BListWW = fuFrame.Keyword.F.Keyword.F.R.BList:GetWidth()
	for id = 1, hang_NUM, 1 do
		local ListBut = CreateFrame("Frame", "KeyBList_"..id, fuFrame.Keyword.F.Keyword.F.R.BList);
		ListBut:SetSize(BListWW,hang_H);
		if id==1 then
			ListBut:SetPoint("TOPLEFT", fuFrame.Keyword.F.Keyword.F.R.BList.Scroll, "TOPLEFT", 0, 0);
		else
			ListBut:SetPoint("TOPLEFT", _G["KeyBList_"..(id-1)], "BOTTOMLEFT", 0, 0);
		end	
		PIGLine(ListBut,"TOP",0,1,{1,-20},{0.5, 0.5, 0.5, 0.2})
		ListBut.del =PIGCloseBut(ListBut,{"LEFT", ListBut, "LEFT", 0,0})
		ListBut.del:SetScript("OnClick", function (self)
			table.remove(PIGA["Chat"]["TiquKey"]["Blacklist"][PIG_renwuming], self:GetID());
			fuFrame.Keyword.F.Keyword.F.R.BList.Scroll.gengxin_list(fuFrame.Keyword.F.Keyword.F.R.BList.Scroll)
		end);	
		ListBut.txt = PIGFontString(ListBut,{"LEFT", ListBut.del, "RIGHT", 4, 0});
		ListBut.txt:SetTextColor(0.7, 0.7, 0.7, 1);
	end
	fuFrame.Keyword.F.Keyword.F.R.BList:HookScript("OnShow", function(self)
		self.Scroll.gengxin_list(self.Scroll)
	end);
end