local addonName, addonTable = ...;
local L=addonTable.locale
local _, _, _, tocversion = GetBuildInfo()
---
local Create=addonTable.Create
local PIGFrame=Create.PIGFrame
local PIGLine=Create.PIGLine
local PIGSlider = Create.PIGSlider
local PIGCheckbutton=Create.PIGCheckbutton
local PIGCheckbutton_R=Create.PIGCheckbutton_R
local PIGOptionsList_R=Create.PIGOptionsList_R
local PIGFontString=Create.PIGFontString
local PIGDownMenu=Create.PIGDownMenu
--
local Common=addonTable.Common
----常用
local fujiF,fujiTabBut =PIGOptionsList_R(Common.NR,L["COMMON_TABNAME"],70)
fujiF:Show()
fujiTabBut:Selected()
---任务提示音
fujiF.QuestsEnd =PIGCheckbutton_R(fujiF,{"任务完成提示音","任务完成提示音"},true)
fujiF.QuestsEnd:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIGA["Common"]["QuestsEnd"]=true;	
	else
		PIGA["Common"]["QuestsEnd"]=false;
	end
	Common.fun.QuestsEnd("Check")
end);
fujiF.QuestsEnd.xiala=PIGDownMenu(fujiF.QuestsEnd,{"LEFT",fujiF.QuestsEnd.Text, "RIGHT", 4,0},{180,24})
function fujiF.QuestsEnd.xiala:PIGDownMenu_Update_But(self)
	local info = {}
	info.func = self.PIGDownMenu_SetValue
	for i=1,#Common.AudioList,1 do
	    info.text, info.arg1 = Common.AudioList[i][1], i
	    info.checked = i==PIGA["Common"]["QuestsEndAudio"]
		fujiF.QuestsEnd.xiala:PIGDownMenu_AddButton(info)
	end 
end
function fujiF.QuestsEnd.xiala:PIGDownMenu_SetValue(value,arg1)
	fujiF.QuestsEnd.xiala:PIGDownMenu_SetText(value)
	PIGA["Common"]["QuestsEndAudio"]=arg1
	PIGCloseDropDownMenus()
end
fujiF.QuestsEnd.PlayBut = CreateFrame("Button",nil,fujiF.QuestsEnd);
fujiF.QuestsEnd.PlayBut:SetNormalTexture("interface/buttons/ui-spellbookicon-nextpage-up.blp")
fujiF.QuestsEnd.PlayBut:SetPushedTexture("interface/buttons/ui-spellbookicon-nextpage-down.blp")
fujiF.QuestsEnd.PlayBut:SetDisabledTexture("interface/buttons/ui-spellbookicon-nextpage-disabled.blp")
fujiF.QuestsEnd.PlayBut:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");--高亮纹理
fujiF.QuestsEnd.PlayBut:SetSize(28,28);
fujiF.QuestsEnd.PlayBut:SetPoint("LEFT",fujiF.QuestsEnd.xiala,"RIGHT",8,-0.5);
fujiF.QuestsEnd.PlayBut:SetScript("OnClick", function()
	PlaySoundFile(Common.AudioList[PIGA["Common"]["QuestsEndAudio"]][2], "Master")
end)
----
if tocversion>20000 then
fujiF.SetFocus = PIGCheckbutton_R(fujiF,{"快速设置焦点","按后方设置的快捷键后点击头像快速设置焦点"},true)
fujiF.SetFocus:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIGA["Common"]["SetFocus"]=true;
		Common.fun.SetFocus()
	else
		PIGA["Common"]["SetFocus"]=false;
		Pig_Options_RLtishi_UI:Show()
	end
end);
fujiF.SetFocus.xiala=PIGDownMenu(fujiF.SetFocus,{"LEFT",fujiF.SetFocus.Text, "RIGHT", 4,0},{120,24})
function fujiF.SetFocus.xiala:PIGDownMenu_Update_But(self)
	local info = {}
	info.func = self.PIGDownMenu_SetValue
	local SetKeyList = Common.SetKeyList
	for i=1,#SetKeyList,1 do
	    info.text, info.arg1, info.arg2 = SetKeyList[i][1], SetKeyList[i][2]
	    info.checked = SetKeyList[i][2]==PIGA["Common"]["SetFocusKEY"]
		fujiF.SetFocus.xiala:PIGDownMenu_AddButton(info)
	end 
end
function fujiF.SetFocus.xiala:PIGDownMenu_SetValue(value,arg1)
	if InCombatLockdown() then PIG_print("战斗中无法更改按键") return end
	fujiF.SetFocus.xiala:PIGDownMenu_SetText(value)
	PIGA["Common"]["SetFocusKEY"]=arg1
	Common.fun.SetFocus()
	PIGCloseDropDownMenus()
end
fujiF.ClearFocus =PIGCheckbutton_R(fujiF,{"快速清除焦点","在焦点头像点击已设置焦点快捷键可快速清除焦点"},true)
fujiF.ClearFocus:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIGA["Common"]["ClearFocus"]=true;
	else
		PIGA["Common"]["ClearFocus"]=false;
		Pig_Options_RLtishi_UI:Show()
	end
	Common.fun.ClearFocus()
end);
end
---性能优化---
fujiF.xingnengF=PIGFrame(fujiF,{"BOTTOMLEFT", fujiF, "BOTTOMLEFT", 0, 0})
fujiF.xingnengF:SetPoint("BOTTOMRIGHT", fujiF, "BOTTOMRIGHT", 0, 0);
fujiF.xingnengF:SetHeight(260)
PIGLine(fujiF.xingnengF,"TOP",0,nil,{0,-340})
PIGLine(fujiF.xingnengF,"TOP",0,nil,{340,0})
fujiF.xingnengF.biaoti = PIGFontString(fujiF.xingnengF,{"TOP",fujiF.xingnengF,"TOP",0,7},"性能优化");
---关闭新版字体
fujiF.xingnengF.offnewfont =PIGCheckbutton_R(fujiF.xingnengF,{"关闭Slug字体特效","关闭10.0之后增加的Slug字体特效。一种新的字体渲染引擎，主要为了改善浮动信息以及姓名板名字效果。但是此功能会导致额外加载时间，某些情况还会导致第一次进战斗卡顿一下"},true)
fujiF.xingnengF.offnewfont:HookScript("OnClick", function (self)
	if self:GetChecked() then
		SetCVar("UseSlug","0")
		PIGA["Common"]["Offnewfont"]=true
	else
		SetCVar("UseSlug","1")
		PIGA["Common"]["Offnewfont"]=false
	end
end);
-----战斗日志
local Opentiaojian = {[1]="只在团本开启",[2]="只在地下城开启",[3]="只在地下城/团本开启",[4]="常驻开启"}
fujiF.xingnengF.CombatLog =PIGCheckbutton_R(fujiF.xingnengF,{"智能开启高级战斗日志","根据预设条件自动开启高级战斗日志"},true)
local function AutoCombatLog()
	if PIGA["CVars"]["AutoCombatLog"] then
		if PIGA["CVars"]["AutoCombatLogTJ"]==4 then
			SetCVar("advancedCombatLogging", "1")
			return
		else	
			local inInstance, instanceType = IsInInstance()
			if PIGA["CVars"]["AutoCombatLogTJ"]==3 then
				if instanceType=="party" or instanceType=="raid" then
					SetCVar("advancedCombatLogging", "1")
					return
				end
			elseif PIGA["CVars"]["AutoCombatLogTJ"]==1 then
				if instanceType=="raid" then
					SetCVar("advancedCombatLogging", "1")
					return
				end
			elseif PIGA["CVars"]["AutoCombatLogTJ"]==2 then
				if instanceType=="party" then
					SetCVar("advancedCombatLogging", "1")
					return
				end
			end
		end
		SetCVar("advancedCombatLogging", "0")
	end
end
Common.fun.AutoCombatLog=AutoCombatLog
local function gengxinONOFF()
	if GetCVar("advancedCombatLogging")=="1" then
		fujiF.xingnengF.CombatLog.Opentj.on:SetText("开")
		fujiF.xingnengF.CombatLog.Opentj.on:SetTextColor(0, 1, 0, 1)
	else
		fujiF.xingnengF.CombatLog.Opentj.on:SetText("关")
		fujiF.xingnengF.CombatLog.Opentj.on:SetTextColor(1, 0, 0, 1)
	end
end
fujiF.xingnengF.CombatLog:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIGA["CVars"]["AutoCombatLog"]=true
	else
		PIGA["CVars"]["AutoCombatLog"]=false
	end
	AutoCombatLog()
	gengxinONOFF()
end);
fujiF.xingnengF.CombatLog.Opentj=PIGDownMenu(fujiF.xingnengF.CombatLog,{"LEFT",fujiF.xingnengF.CombatLog.Text,"RIGHT",10,0},{190,nil})
fujiF.xingnengF.CombatLog.Opentj.tt = PIGFontString(fujiF.xingnengF.CombatLog.Opentj,{"LEFT",fujiF.xingnengF.CombatLog.Opentj,"RIGHT",10,0},"当前状态:");
fujiF.xingnengF.CombatLog.Opentj.on = PIGFontString(fujiF.xingnengF.CombatLog.Opentj,{"LEFT",fujiF.xingnengF.CombatLog.Opentj.tt,"RIGHT",4,0},"关","OUTLINE",15);
function fujiF.xingnengF.CombatLog.Opentj:PIGDownMenu_Update_But(self)
	local info = {}
	info.func = self.PIGDownMenu_SetValue
	for i=1,#Opentiaojian,1 do
	    info.text, info.arg1 = Opentiaojian[i], i
	    info.checked = i==PIGA["CVars"]["AutoCombatLogTJ"]
		fujiF.xingnengF.CombatLog.Opentj:PIGDownMenu_AddButton(info)
	end 
end
function fujiF.xingnengF.CombatLog.Opentj:PIGDownMenu_SetValue(value,arg1,arg2)
	fujiF.xingnengF.CombatLog.Opentj:PIGDownMenu_SetText(value)
	PIGA["CVars"]["AutoCombatLogTJ"]=arg1
	PIGCloseDropDownMenus()
	AutoCombatLog()
	gengxinONOFF()
end
---
fujiF:RegisterEvent("PLAYER_ENTERING_WORLD");
fujiF:SetScript("OnEvent",function (self,event,arg1,arg2)
	if event=="PLAYER_ENTERING_WORLD" then
		AutoCombatLog()
	end
end)
--
fujiF:HookScript("OnShow", function (self)
	fujiF.QuestsEnd :SetChecked(PIGA["Common"]["QuestsEnd"]);
	fujiF.QuestsEnd.xiala:PIGDownMenu_SetText(Common.AudioList[PIGA["Common"]["QuestsEndAudio"]][1])
	if tocversion>20000 then
		fujiF.SetFocus:SetChecked(PIGA["Common"]["SetFocus"]);
		fujiF.SetFocus.xiala:PIGDownMenu_SetText(Common.SetKeyListName[PIGA["Common"]["SetFocusKEY"]])
		fujiF.ClearFocus:SetChecked(PIGA["Common"]["ClearFocus"]);
	end
	if PIGA["Common"]["Offnewfont"] then
		SetCVar("UseSlug","0")
		self.xingnengF.offnewfont:SetChecked(true)
	end
	--
	gengxinONOFF()
	self.xingnengF.CombatLog:SetChecked(PIGA["CVars"]["AutoCombatLog"]);
	self.xingnengF.CombatLog.Opentj:PIGDownMenu_SetText(Opentiaojian[PIGA["CVars"]["AutoCombatLogTJ"]])
end);